#charset "us-ascii"

#include <tads.h>
#include "advlite.h"

versionInfo: GameID
    IFID = '243748b1-5310-4916-8436-890e9ccc16fd'
    name = 'test'
    byline = 'by Jerry Ford'
    htmlByline = 'by <a href="mailto:jerry.o.ford@gmail.com">
                  Jerry Ford</a>'
    version = '1'
    authorEmail = 'Jerry Ford <jerry.o.ford@gmail.com>'
    desc = 'Testing adv3lite character conversations.'
    htmlDesc = 'Testing adv3lite character conversations.'
;

gameMain: GameMainDef
    /* the initial player character is 'harry' */
    initialPlayerChar = harry
    paraBrksBtwnSubcontents = nil
    usePastTense = true
;

// harry, main character
harry: Actor 'Harry;;man self' @harrysBedroom
    ""
    contType = Carrier
    globalParamName = 'harry'
    isFixed = true   
    isHim = true
    isInitState = true
    ownsContents = true
    person = 3   
    proper = true
    bulkCapacity = 5000
    hasShowered = nil
;

modify Thing
    dobjFor(Answer)
    {
        preCond = [objHeld]
        verify() { illogical(cannotAnswerMsg);}
        report() { "{I} answered the <<gDobj>>. "; }
    }
    cannotAnswerMsg = '{I} {can\'t} answer {that dobj}. '
;

VerbRule(Answer)
    'answer' singleDobj
    : VerbProduction
    action = Answer
    verbPhrase = 'answer/answering'
    missingQ = 'answer what'
;
DefineTAction(Answer)
;

harrysBedroom: Room
    'Bedroom' 'bedroom; room'
    "Harry's bedroom"
;
+ cellPhone: Thing 'cell phone;;telephone phone cell mobile'
    "The cell phone was an older model, no data plan, just basic telephone
    service, and, of course, a camera. "
    
    isRinging = nil
    
    ringing()
    {
        if(!gRevealed('newClient'))
        {
            isRinging = true;
            "Harry felt a vibration on his left thigh, and a ringing noise rose out
            of his pocket. After a moment's hesitation, he realized it was his cell phone
            trying to attract his attention. 
            <.p>";
        }
    }
    dobjFor(Answer)
    {
        verify(){}
        action()
        {
            "Harry looked at the phone's screen. 
            <<if !isRinging>>There was nothing displayed for an incoming call. There was no connection. The phone had
            not rung. \"Now why did I do that?\" {I} wondered. <<end>>";
            if(isRinging && phoneCallFromMona.isHappening)
            {
                "It was Mona. What now, he wondered, as he prepared to talk to Mona.";

                commLink.connectTo(mona);
                
                if(phoneCallFromMona.conversationWithMona != nil)
                {
                    phoneCallFromMona.conversationWithMona.removeEvent();
                    phoneCallFromMona.conversationWithMona = nil;
                }
            }
            isRinging = nil;
        }
    }
;
// topics
tMonaOnPhone: Topic 'the call';
tNewClient: Topic 'new client';

phoneCallFromMona: Scene
    startsWhen = cellPhone.isIn(harry)
    endsWhen = (gRevealed('newClient'))
    
    conversationWithMona = nil
    
    whenStarting()
    {
        conversationWithMona = new Daemon(cellPhone, &ringing, 3);
        mona.setState(monaTalkingAboutGrace);
    }
    whenEnding()
    {
        commLink.disconnectFrom(mona);
        if(conversationWithMona != nil)
        {
            conversationWithMona.removeEvent();
            conversationWithMona = nil;
        }
        mona.setState(nil);
    }
;

harrysOffice: Room 'harry\'s office' 'office'
    "Harry's Office"
;

// mona character (harry's secretary/office assistant/business manager)
mona: Actor 'mona;attractive blonde petite;woman;her' @harrysOffice
    "Mona was an attractive, mid-30ish woman, small in stature with a big
    smile and wavy blonde hair that cascaded over her shoulders.
    <.p> "
        
    globalParamName = 'mona'
    person = 3   
    bulkCapacity = 5000
    
    attentionSpan = 3
;
+ monaTalkingAboutGrace: ActorState
    
;
++ HelloTopic
    "\"Hey, Mona, 'sup?\" Harry said breezily. \b
    \"Don\'t you \'sup me,\" she sneered. \"Where'd you go to get all hip-hop
    at your age?\" "
;
++ DefaultAskTellTopic
    "\"Don\'t mess with me, Harry,\" Mona said. \"I probably know more about
    that sort of thing than you do.\""
;
++ AskTopic @tMonaOnPhone
    "<q>Mona, babe, what<<first time>>'s happening? What<<only>> d'ya need?</q> Harry said. \b
    <q>Where are you?</q> she demanded. <q><<first time>>Why aren\'t you here, in the
    office? <<only>>There's <<first time>>been someone here to see you,
    <<only>>a possible new client.</q> <.convnode newClient>"
    
    name = 'the call'
    curiositySatisfied = gRevealed('newClient')
;
+ ConvNode 'newClient'
;
++ AskTopic, StopEventList @tNewClient
    eventList = 
    [
        {: "<q>Mona, babe, what's happening</q> Harry said. \b
            <q>Where are you? Why aren]t you here, in the office? There's
            someone looking for you, a prospective new client</q> she replied 
            coldly. <.convstay> "},
        
        {: "<q>Babe, I love you, you know I do, but come on, I've got a life.
        You should get one, too,</q> he replied. \b
        <q>Life is one thing, work is another,</q> she replied coldly.
        <q>And it's a work day. Speaking of...</q> <.convstay>"},
        
        {: "You have a new prospective client. A woman. Name is Grace Oscuro.
        She dropped by this
        morning, asking if you were in. She seems to know who you are, she was
        disappointed when you weren\'t here. I told her I would be in touch.
        She wants to meet with you. Soon. She said it\'s urgent.\" Mona paused,
        waiting for Harry\'s reply. <.convstay>"},
        
        {: "\"Woman, huh? Good looking?\" he teased. \b
        \"Pig,\" Mona replied. Then, after a pause, \"Yes. Good looking.
        Somewhat tall, thin, long dark hair that matched her dark outfit,
        except for a bright yellow scarf entwined in her French braid. Very
        stylish, even with her black-framed librarian\'s glasses.\" <.convstay>"},
        
        {: "\"Mona, don\'t snipe, jealously doesn\'t become you,\" Harry responded.
        \"What\'d you tell her?\" He was definitely interested now. \b
        \"That I would talk to you and let her know. She\'s coming back this
        afternoon.\" <.convstay>"},
        
        {: "<q>Okay, doll, you did good. I can\'t be there today...</q> he wanted to
        talk to Mike the tattoo man first before any encounter with the dark angel, who he
        was pretty sure she was, <q>...but I do want to meet with her.  Say
        tomorrow?</q> \b
        <q>You have a date with Max tomorrow, Harry,</q> Mona said. <.convstay>"},
        
        {:"<<first time>>\"Yeah, that\'s right, I do,\" he answered. \"So, we\'ll mix business
        with family. Tell her to meet me at the <<only>>Maritime Museum tomorrow
        at 2<<first time>>
        p.m<<only>>.\" \b
        \"Okay<<first time>>, Harry, I\'ll pass it on<<only>>.\"<.reveal
            newClient> "}
    ]
    
    name = 'new client'
;
++ NodeEndCheck
    canEndConversation(reason)
    {
        switch(reason)
        {
            case endConvBye:
                "\"Harry, don't you dare hang up on me, we've still got business to
                discuss,\" Mona said with a tone of authority that made Harry
                pause. 
                </p>";
                return blockEndConv;
            case endConvLeave:
                "<q>Harry, pick that phone back up right now!</q> Mone shouted, loud enough that Harry
                heard her even though he had dropped the phone away from his
                ear. He quickly lifted it back to the side of his head.\b
                <q>Sorry, babe, momentary brain fart,</q> he apologized. 
                <.p>";
                return blockEndConv;
            default:
                return nil;
        }
    }
;
++ DefaultTellTopic
    "<q>Sometimes, Harry, I think you're not quite right in the head, you know
    that?</q> Mona said with a sigh. <q>I just don't understand you
    sometimes.</q> "
;
++ DefaultAnyTopic
    "<q>Harry, this is important! You don't want your business to fail, do
    you?</q> Mona said. "
;
++ NodeContinuationTopic
    "<q>Harry, are we still talking about making your business run?</q> Mona said. "
;
